-- VHDL model created from slave.sch - Sun Oct 03 23:14:03 2004


library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on

entity slave is
   port ( clk          : in    std_logic; 
          MOSI         : in    std_logic; 
          reset        : in    std_logic; 
          SCK          : in    std_logic; 
          slave_enable : in    std_logic; 
          ss_n         : in    std_logic; 
          TXData       : in    std_logic_vector (7 downto 0); 
          busy         : out   std_logic; 
          done         : out   std_logic; 
          MISO         : out   std_logic; 
          RXData       : out   std_logic_vector (7 downto 0)
			 );
end slave;

architecture BEHAVIORAL of slave is
   signal XLXN_25      : std_logic;
   signal XLXN_26      : std_logic;
   signal XLXN_31      : std_logic;
   signal XLXN_39      : std_logic;
   signal XLXN_40      : std_logic;
   signal XLXN_43      : std_logic;
   signal XLXN_44      : std_logic;
   component slave_sm
      port ( clk          : in    std_logic; 
             reset        : in    std_logic; 
             enable       : in    std_logic; 
             sck_fe       : in    std_logic; 
             sck_re       : in    std_logic; 
             ss_fe        : in    std_logic; 
             ss_re        : in    std_logic; 
             shift_enable : out   std_logic; 
             reset_sr     : out   std_logic; 
             busy         : out   std_logic; 
             loadxmit     : out   std_logic; 
             done         : out   std_logic);
   end component;
   
   component slave_input_sr
      port ( clk          : in    std_logic; 
             reset        : in    std_logic; 
             sr_reset     : in    std_logic; 
             shift_enable : in    std_logic; 
             sin          : in    std_logic; 
             Data_out     : out   std_logic_vector (7 downto 0); 
             sck_re       : in    std_logic);
   end component;
   
   component slave_output_sr
	    Port ( 	Datain : in std_logic_vector(7 downto 0);
      	 	clk   : in std_logic;
		 		sck_fe: in std_logic;
		 		reset  : in std_logic;
           	load : in std_logic;
		 		enable: in std_logic;
           	miso_out : out std_logic);
   end component;


   
   component edge_detect
      port ( edclk    : in    std_logic; 
             clk      : in    std_logic; 
             reset    : in    std_logic; 
             edclk_fe : out   std_logic; 
             edclk_re : out   std_logic);
   end component;
   
begin
   FSM : slave_sm
      port map (clk=>clk, enable=>slave_enable, reset=>reset, sck_fe=>XLXN_39,
            sck_re=>XLXN_40, ss_fe=>XLXN_43, ss_re=>XLXN_44, busy=>busy, done=>done,
            loadxmit=>XLXN_25, reset_sr=>XLXN_31, shift_enable=>XLXN_26);
   
   INPUT_SR : slave_input_sr
      port map (clk=>clk, reset=>reset, sr_reset=>XLXN_31,shift_enable=>XLXN_26,
            sin=>MOSI,  Data_out(7 downto 0)=>RXData(7
            downto 0), sck_re=>XLXN_40);
   
   OUTPUT_SR : slave_output_sr
      port map (clk=>clk, Datain(7 downto 0)=>TXData(7 downto 0),
            enable=>slave_enable, load=>XLXN_25, reset=>reset, sck_fe=>XLXN_39,
            miso_out=>MISO);
   
   XLXI_1 : edge_detect
      port map (clk=>clk, edclk=>SCK, reset=>reset, edclk_fe=>XLXN_39,
            edclk_re=>XLXN_40);
   
   XLXI_2 : edge_detect
      port map (clk=>clk, edclk=>ss_n, reset=>reset, edclk_fe=>XLXN_43,
            edclk_re=>XLXN_44);
   
end BEHAVIORAL;


