
-- VHDL Test Bench Created from source file slave.vhd -- 22:55:17 07/30/2005
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY slave_tb_slave_vhd_tb IS
END slave_tb_slave_vhd_tb;

ARCHITECTURE behavior OF slave_tb_slave_vhd_tb IS 

	COMPONENT slave
	PORT(
		clk : IN std_logic;
		MOSI : IN std_logic;
		reset : IN std_logic;
		SCK : IN std_logic;
		slave_enable : IN std_logic;
		ss_n : IN std_logic;
		TXData : IN std_logic_vector(7 downto 0);          
		busy : OUT std_logic;
		done : OUT std_logic;
		MISO : OUT std_logic;
		RXData : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;

	SIGNAL clk :  std_logic;
	SIGNAL MOSI :  std_logic;
	SIGNAL reset :  std_logic;
	SIGNAL SCK :  std_logic;
	SIGNAL slave_enable :  std_logic;
	SIGNAL ss_n :  std_logic;
	SIGNAL TXData :  std_logic_vector(7 downto 0);
	SIGNAL busy :  std_logic;
	SIGNAL done :  std_logic;
	SIGNAL MISO :  std_logic;
	SIGNAL RXData :  std_logic_vector(7 downto 0);

BEGIN

	uut: slave PORT MAP(
		clk => clk,
		MOSI => MOSI,
		reset => reset,
		SCK => SCK,
		slave_enable => slave_enable,
		ss_n => ss_n,
		TXData => TXData,
		busy => busy,
		done => done,
		MISO => MISO,
		RXData => RXData
	);


-- *** Test Bench - User Defined Section ***
   tb_clk : PROCESS
   BEGIN
      clk<='0'; wait for 10 ns;
		clk<='1'; wait for 10 ns;
   END PROCESS;

	tb_reset: process
	begin
		reset<='1'; wait for 100 ns;
		reset<='0'; wait;
	end process;

	-- feedback test
	MOSI<=MISO;

	tb_data: process
	variable cnt: integer;
	begin
		-- init

		SCK<='0';
		slave_enable<='1';
		ss_n<='1';
		TXData<=x"A5";
		
		wait for 200 ns;
		-- activate slave
		ss_n<='0';

		wait for 2000 ns;

		for i in 0 to 7 loop
			sck<='0'; wait for 200 ns;
			sck<='1'; wait for 200 ns;	
		end loop;
		sck<='0';
		wait for 2000 ns;
		ss_n<='1';

		wait for 4000 ns;
			
		wait;  

	end process;
-- *** End Test Bench - User Defined Section ***

END;
